!=======================================================================        
      
      subroutine cube_to_box(cube_coord, box_coord,dim_sim, &
     &                       k_bar, a_bar, k_up, a_up, range_cube)
      
!=======================================================================  
      
      implicit none
      
      integer, intent(in)  :: dim_sim
      real(8), intent(in)  :: k_bar, a_bar, k_up, a_up, range_cube
      
      real(8), intent(in)  :: cube_coord(dim_sim)
      real(8), intent(out) :: box_coord(dim_sim)
      
      integer :: i,half_dim 
      real(8) :: scaling_k, scaling_a 

      real(8) :: dummy_coord_cube
      real(8), parameter :: eps = 0.
      
!-----------------------------------------------------------------------        
!.....check that dimensionality is a multiple of 2
      if (mod(dim_sim, 2) .ne. 0) then
        write(6,*) 'Error: dimensionality of simulation should be multiple of 2'
        stop
!-----------------------------------------------------------------------          
      else       
!-----------------------------------------------------------------------        
!.....linear transformation of a(j), k(j)
        scaling_a = (range_cube/(a_up - a_bar))  !scaling for a
        scaling_k = (range_cube/(k_up - k_bar))  !scaling for k
        
        half_dim = dim_sim/2

!.....a(j) : [exp(-0.8*sigma/(1-rho)),..,exp(0.8*sigma/(1-rho))]  -> [0,..,1]          
        do i = 1,half_dim
          dummy_coord_cube = cube_coord(i)
          if (dummy_coord_cube .le. eps) then
            dummy_coord_cube = cube_coord(i) + eps
          end if
          box_coord(i) = dummy_coord_cube/scaling_a + a_bar
        end do           
        
!.....k(j) : [0.8,..,1.2] -> [0,..,1] 
        do i = half_dim + 1, dim_sim
          dummy_coord_cube = cube_coord(i)
          if (dummy_coord_cube .le. eps) then
            dummy_coord_cube = cube_coord(i) + eps
          end if
          box_coord(i) = dummy_coord_cube/scaling_k + k_bar      
        end do

     
!-----------------------------------------------------------------------         
      end if
      
!-----------------------------------------------------------------------       
      end subroutine cube_to_box
!-----------------------------------------------------------------------         