!=======================================================================  

      subroutine box_to_cube(box_coord, cube_coord,dim_sim, & 
     &                               k_bar, a_bar, k_up, a_up, range_cube)
      
!=======================================================================         

      implicit none


      integer, intent(in)  :: dim_sim
      real(8), intent(in)  :: k_bar, a_bar, k_up, a_up, range_cube
     
      real(8), intent(in)  :: box_coord(dim_sim)
      real(8), intent(out) :: cube_coord(dim_sim)
      
      integer :: i,half_dim 
      real(8) :: scaling_k, scaling_a 
      
      real(8) :: dummy_coord_box
      real(8), parameter :: eps = 0.
   
!-----------------------------------------------------------------------        
!.....check that dimensionality is a multiple of 2
      if (mod(dim_sim, 2) .ne. 0) then
        write(6,*) 'Error: dimensionality of simulation should be multiple of 2'
        stop
!-----------------------------------------------------------------------  
      else 
      
!-----------------------------------------------------------------------        
!.....linear transformation of a(j), k(j)      
        scaling_a = (range_cube/(a_up-a_bar))  !scaling for a
        scaling_k = (range_cube/(k_up-k_bar))  !scaling for k
        
        half_dim = dim_sim/2                     

!.....a(j) : [exp(-0.8*sigma/(1-rho)),..,exp(0.8*sigma/(1-rho))]  -> [0,..,1]  
        do i = 1,half_dim
          dummy_coord_box = box_coord(i)  
          
!.....prevent "bad" values out of the box          
          if (dummy_coord_box .ge. a_up ) then
            dummy_coord_box = a_up - eps
          else if (dummy_coord_box .le. a_bar) then
            dummy_coord_box = a_bar + eps
          end if
!.....transformation to cube          
          cube_coord(i) = (dummy_coord_box-a_bar)*scaling_a 
        end do        
                
!.....k(j) : [0.8,..,1.2] -> [0,..,1] 
        do i = half_dim + 1, dim_sim
          dummy_coord_box = box_coord(i)  
      
!.....prevent "bad" values out of the box          
          if (dummy_coord_box .ge. k_up ) then
            dummy_coord_box = k_up -eps
          else if (dummy_coord_box .le. k_bar) then
            dummy_coord_box = k_bar + eps
          end if
!.....transformation onto cube [0,1]^d        
          cube_coord(i) = (dummy_coord_box-k_bar)*scaling_k   
        end do
        
!-----------------------------------------------------------------------             
      end if
      
!-----------------------------------------------------------------------             
      end subroutine box_to_cube
!-----------------------------------------------------------------------             
  