/* AdaptiveDataStructure

   This is the class derived from the datastructure class.

   This class defines the datastructure for the implmentation of BlockAllocator.

  - AdatpvieARRAY defines an D-dimensional array to store the coorinates for each interpolation point.

  - AdaptiveNodeData stores the information associated with each multi-index j.

  - AdaptiveData stores the information associated with each mult-index i.

  - AdaptiveNodeDataCompare  a struct used in the standard template librarty <set> to compare two multi-index j

  - AdaptiveDataCompare      a struct used in the standard template librarty <set> to compare two multi-index i

*/


#ifndef AdaptiveDataStructure_h_is_included
#define AdaptiveDataStructure_h_is_included

#include "DataStructure.h"
#include <set>


template<class Data>
class AdaptiveARRAY : public Array<Data>
{
public:
	AdaptiveARRAY():Array<Data>(){
	};
	virtual ~AdaptiveARRAY(){Delete();};

	virtual void Init(int dim){this->redim(dim);this->fill(0.0);};

	virtual void Clear(){this->fill(0.0);} ;

	virtual void Delete(){this->cleanup();} ;

};

class AdaptiveNodeData
{
  public:
 //! default constructor
  AdaptiveNodeData(){index = NULL; surplus = NULL;};
  virtual ~AdaptiveNodeData() {Delete();}

  AdaptiveARRAY<int> *index;
  double *surplus ;

  virtual void Init(){};

  virtual void Clear(){index=NULL; surplus=NULL;};

  virtual void Delete(){
	  if (surplus) {delete[] surplus; surplus= NULL;}
	  index = NULL;
  } ;
};

struct AdaptiveNodeDataCompare { bool operator()( AdaptiveNodeData*, AdaptiveNodeData* )  ; } ;


class AdaptiveData
{
public:
	 //! default constructor
	AdaptiveData();
	~AdaptiveData() {Delete();}

  AdaptiveARRAY<int> *index;
  set< AdaptiveNodeData*, AdaptiveNodeDataCompare> NodeData;

  virtual void Init();

  virtual void Clear() ;

  virtual void Delete() ;
};

struct AdaptiveDataCompare { bool operator()( AdaptiveData*, AdaptiveData* )  ; } ;
#endif

