//!.....dimension of simulation grid  
	int dim = 4;  

//!.....Degrees of freedom; #No of policies to simulate on
	int DofPerNode = dim / 2 + 1; 
	int N = DofPerNode ; 
	
//!.....simulation
	int no_rand_points = 10000;//length of simulated path

//.....verbosity -- 0: no status, 1: status where simulation is
	int verbosity = 0;	
	
//!.....model parameters
	double beta = 0.99;
	double alpha = 0.36;
	double delta = 0.01;
	double sigma = 0.01;
	double rho = 0.95;
	double phi = 0.5;
	double big_A = (1 - beta + beta * delta) / (alpha * beta);
	double k_bar = 0.8;   
	double k_up = 1.2;   
	double a_bar = exp((-0.8 * sigma) / (1. - rho)); 
	double a_up = exp((0.8 * sigma) / (1. - rho)); 
	double range_cube = 1.; //range of sparse grid in 1D
	
//!.....Initialize gamma (Juillard et al. 2011 - JDC, Table 2)
//!.....gamma equally spread over [0.25,1]
	double range_up = 1;
	double range_down = 0.25;
	double range = range_up - range_down;

//!.....auxiliary vars
	double *fvalue = new double[N];	
	double *fvalue_pp = new double[N];	
	double growth, growth_plus;
	double int_coord; 
	double dividend_eq, divisor_eq, quot_eq; 
	double max_max_error = -10;
	double ave_max = 0;
	double ave_ave = 0.0;	
	int max_coord_pointer = 1;	