
!=======================================================================        
      
      subroutine cube_to_box(cube_coord, box_coord)
      
!=======================================================================  
      use parameter_module, only: dim_sim, mu_up, mu_down, g_up,  & 
     &                            g_down, p_up, p_down, prec
      
      
      implicit none
      
      real(prec), intent(in)   :: cube_coord(dim_sim)
      real(prec), intent(out)  :: box_coord(dim_sim)

      real(prec) :: scaling_mu, scaling_g, scaling_p 
      !real(prec), parameter :: eps = 0.!0.01
      real(prec), parameter :: range_cube = 1.0 !domain size [0..1]^d
      
!-----------------------------------------------------------------------        
!.....check that dimensionality is a multiple of 2
      if (mod(dim_sim, 4) .ne. 0) then
        write(6,*) 'Error: dimensionality of simulation should be 4'
        stop
!-----------------------------------------------------------------------  
      else   

!-----------------------------------------------------------------------        
!.....linear transformation of mu, g, p    
        scaling_mu = (range_cube/(mu_up-mu_down))  !scaling for mu
        scaling_g  = (range_cube/(g_up- g_down))   !scaling for g               
        scaling_p  = (range_cube/(p_up-p_down))    !scaling for p   
  
!.....transformation to box      
        box_coord(1) = cube_coord(1)/scaling_mu + mu_down 
        box_coord(2) = cube_coord(2)/scaling_mu + mu_down 
        box_coord(3) = cube_coord(3)/scaling_g  + g_down 
        box_coord(4) = cube_coord(4)/scaling_p  + p_down 

       
!-----------------------------------------------------------------------         
      end if
      
!-----------------------------------------------------------------------       
      end subroutine cube_to_box
!-----------------------------------------------------------------------             
      
!=======================================================================
